/*
 * Kalender.cpp
 *
 *  Created on: 14.04.2011
 *      Author: martin
 */
#include <iostream>
#include <string>
using namespace std;

// speichert ein Datum. Selbsterklärend.
struct Datum{
	int iTag, iMonat, iJahr;
};

/** nEinlesen liest ein Datum ein und gibt es im Format Datum zurück.
 * Eingabefehler werden in dieser Version nicht korrigiert!
 *
 */
Datum nEinlesen()
{
	std::string sEingabe;
	Datum nResult;

	cout << "Geben Sie das Datum im Format TT.MM.JJJJ ein.\t";
	cin >> sEingabe;

	// Zerlegung gemäß Position in der ASCII-Tabelle
	nResult.iTag = (((int)sEingabe[0]-48)*10 + (int)sEingabe[1]-48);
	nResult.iMonat = (((int)sEingabe[3]-48)*10 + (int)sEingabe[4]-48);
	nResult.iJahr = (((int)sEingabe[6]-48)*1000
			+ ((int)sEingabe[7]-48)*100 + ((int)sEingabe[8]-48)*10
			+ (int)sEingabe[9]-48);
	return nResult;
}

// testet, ob ein Jahr ein Schaltjahr ist. Ist dann != 0.
int iSchaltjahr(int iJahr)
{
	return (iJahr % 4 == 0) && (iJahr % 100 != 0) || (iJahr % 400 == 0);
}

// für die Textausgabe. gibt " " oder "k" zurück.
char sSchaltjahrTest(int iJahr)
{
	string sEinKein = "k ";
	return sEinKein[iSchaltjahr(iJahr)];
}

/** berechnet den aktuellen Wochentag.
 * Beginnt, analog zur Darstellung im Script, mit dem Sonntag als
 * ersten Wochentag.
 *
 */
string sBerechneWochentag(int iGesamtTage)
{
	string sWochentage[7]={"Sonntag.", "Montag.", "Dienstag.", "Mittwoch.", "Donnerstag.", "Freitag.", "Samstag."};
	return sWochentage[iGesamtTage % 7];
}

/** berechnet die im Jahr bisher vergangenen Tage.
 *
 */
int iTageImJahr(Datum nZielDatum)
{
	int iMonate[12] = {
			0,
			31,	//Jan abgeschlossen
			31+28,	//Feb abgeschlossen
			31+28+31,	//Mrz abge...
			31+28+31+30,	//Apr
			31+28+31+30+31,	//Mai
			31+28+31+30+31+30,	//Jun
			31+28+31+30+31+30+31,	//Jul
			31+28+31+30+31+30+31+31,	//Aug
			31+28+31+30+31+30+31+31+30,	//Sep
			31+28+31+30+31+30+31+31+30+31,	//Okt
			31+28+31+30+31+30+31+31+30+31+30,	//Nov
			//Ein abgeschlossener Dez wird bei den Jahren mitgerechnet.
	};
	return (iMonate[nZielDatum.iMonat-1] + nZielDatum.iTag +
			(iSchaltjahr(nZielDatum.iJahr) && (nZielDatum.iMonat >= 3)));
	//falls das Jahr ein Schaltjahr und der Monat >= März ist, wird noch der Schalttag addiert.
}

int main(int argc, char **argv) {
	Datum nZielDatum;
	int iSchaltjahre = 0;
	int iNormJahre = 0;
	int iGesamtTage = 0;

	nZielDatum = nEinlesen();

	// Kontrolle, ob richtig eingegeben wurde.
	cout << nZielDatum.iTag << "." << nZielDatum.iMonat << "."
			<< nZielDatum.iJahr << " wird analysiert..." << endl;

	// Testen, ob das Jahr ein Schaltjahr ist.
	cout << "Das Jahr " << nZielDatum.iJahr << " ist "
			<< sSchaltjahrTest(nZielDatum.iJahr)
			<< "ein Schaltjahr." << endl;

	// Schaltjahre, norm. Jahre und Tage ausrechnen.
	iSchaltjahre = (nZielDatum.iJahr-1) / 4
			- (nZielDatum.iJahr-1) / 100
			+ (nZielDatum.iJahr-1) / 400;
	iNormJahre = nZielDatum.iJahr-1 - iSchaltjahre;
	iGesamtTage = iSchaltjahre * 366 + iNormJahre * 365
			+ iTageImJahr(nZielDatum);

	// Werte ausgeben, Wochentag berechnen und ausgeben.
	cout << "Anzahl der Schaltjahre:\t" << iSchaltjahre << "\n"
			<< "Anzahl normaler Jahre:\t" << iNormJahre <<"\n"
			<< "Anzahl der Tage:\t" << iGesamtTage << endl;
	cout << "Der Wochentag ist ein " << sBerechneWochentag(iGesamtTage) << endl;

	return 0;
}
