//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 4.1: Dynamische Datenstrukturen
//
// Datei:  Stack.cpp
// Inhalt: Stack mit Push- und Pop-Funktion
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "Stack.h"

//////////////////////////////////////////////////////////////////////////////
///////////////////////// Funktions-Implementierung //////////////////////////
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////

Stack::Stack()
{
	head = NULL; 	//f
	tail = NULL;	//g
}

//////////////////////////////////////////////////////////////////////////////
void Stack::push(const Student& stud)
/** \brief push fügt einen neuen Datensatz zum Stack hinzu.
 *
 * Ein neues Listenelement wird angelegt, in welches der Datensatz eingekapselt wird.
 * Dann wird geprüft, ob das Stack leer ist (tail == NULL). Dann werden tail und head auf
 * den neuen Datensatz gesetzt.
 * Anderenfalls wird head auf den neuen Datensatz gesetzt, während dessen next-Zeiger auf
 * den alten Head zeigt.
 *
 */
{
	ListElem* neu = new ListElem;
	neu->data = stud;
	if (tail == NULL)
	{
		neu->next = NULL;
		tail = neu;
		head = neu;
	}
	else
	{
		neu->next = head;
	}
	head = neu;
}

//////////////////////////////////////////////////////////////////////////////
bool Stack::pop(Student& stud)
/** \brief pop löst den obersten Datensatz aus dem Stack.
 * gibt false zurück, falls der Stack leer war. Gibt sonst true zurück.
 *
 * Testet den Stack zunächst auf Leerheit und terminiert für leere Stacks sofort.
 * Anderenfalls wird der Inhalt des ersten Datensatzes per call-by-ref übergeben, der
 * head-Zeiger auf den Nachfolger des ersten Datensatzes geschoben und dieser dann
 * freigegeben.
 *
 */
{
	if (tail == NULL) return false;
	else if (head == tail)
	{
		stud = head->data;
		delete head;
		head = NULL;
		tail = NULL;
	}
	else
	{
		ListElem* cursor = head;
		stud = head->data;
		head = head->next;
		delete cursor;
	}
	return true;
}

//////////////////////////////////////////////////////////////////////////////
/** \brief ausgabe gibt den Stack im aktuellen Zustand aus.
 *
 * Dazu wird ein Cursor von head beginnend so lange durch den Stack geschoben,
 * bis er bei tail angekommen ist.
 *
 */
void Stack::ausgabe()
{
	if (head == NULL) cout << "Der Stack ist leer." << endl;
	else
	{
		ListElem* cursor = head;
		while(cursor != NULL)
		{
			cout << cursor->data.name << ", MatNr. " << cursor->data.matNr << " geb. am "
					<< cursor->data.gebDatum << " wohnhaft in " << cursor->data.adresse << endl;
			cursor = cursor->next;
		}
	}
}




