//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 4.2: Dynamische Datenstrukturen
//
// Datei:  List.cpp
// Inhalt: Liste mit Methoden
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "List.h"

//////////////////////////////////////////////////////////////////////////////
///////////////////////// Funktions-Implementierung //////////////////////////
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// Konstruktor mit Zeigerinitialisierung
List::List()
{
	head = NULL;
	tail = NULL;
}

//////////////////////////////////////////////////////////////////////////////
// vorne an head anfügen
void List::enqueuehead(const Student& stud)
{
	ListElem* neu = new ListElem;
	neu->data = stud;
	neu->prev = NULL; // das erste Element hat keinen Vorgänger.
	if (tail == NULL) // Liste leer??
	{
		neu->next = NULL;
		tail = neu;
	}
	else 
	{
		neu->next = head;
		head->prev = neu; // neues Element wird Vorgänger des alten ersten Elementes.
	}
	head = neu;
}

//////////////////////////////////////////////////////////////////////////////
// Element hinten abhängen
bool List::dequeue(Student& stud)
{
	ListElem* cursor = head;
	if (head == NULL)   //Liste leer??
	{
		return false;;
	}
	else if (head == tail) // Ein Element in Liste
	{
		stud = head->data;
		delete head;
		head = NULL;
		tail = NULL;
	}
	else
	{
		while(cursor->next != tail)
		{
			cursor = cursor->next;
		}
		stud = tail->data;
		tail = cursor;
		delete cursor->next; //prev-Zeiger von cursor->next wird abgerissen.
		tail->next = NULL;
	}
	return true;
}

//////////////////////////////////////////////////////////////////////////////
// von vorne nach hinten ausgeben
void List::ausgabevorwaerts()
{
	ListElem* cursor = head;
	while (cursor != NULL)
	{
		cout << cursor->data.name << ", MatNr. " << cursor->data.matNr << " geb. am " 
			 << cursor->data.gebDatum << " wohnhaft in " << cursor->data.adresse << endl;
		cursor=cursor->next;
	}
}

//////////////////////////////////////////////////////////////////////////////
// von hinten nach vorne ausgeben, gleiches Verfahren wir ausgabevorwaerts.
void List::ausgaberueckwaerts()
{
	ListElem* cursor = tail;
	while (cursor != NULL)
	{
		cout << cursor->data.name << ", MatNr. " << cursor->data.matNr << " geb. am "
			 << cursor->data.gebDatum << " wohnhaft in " << cursor->data.adresse << endl;
		cursor=cursor->prev;
	}
}

////////////////////////////////////////////////////////////////////////////////
// Eintrag suchen und löschen
bool List::eintragloeschen(int matrikelnummer)
{
	ListElem* cursor = head;

	if (head == NULL)   //Liste leer??
	{
		return false;;
	}
	else if (head == tail && head->data.matNr == matrikelnummer) // zu löschendes Element ist einziger Eintrag
	{
		delete head;
		head = NULL;
		tail = NULL;
		return true;
	}
	else if(head->data.matNr == matrikelnummer) // zu löschendes Element am Anfang der Liste
	{
		head = head->next;
		head->prev = NULL;
		delete cursor;
		return true;
	}
	else if(tail->data.matNr == matrikelnummer) // zu löschendes Element am Ende der Liste
	{
		cursor = tail;
		tail = tail->prev;
		tail->next = NULL;
		delete cursor;
		return true;
	}
	else // zu löschendes Element irgendwo sonst in der Liste
	{
		while (cursor != NULL)
		{
			if (cursor->data.matNr == matrikelnummer) // Eintrag gefunden
			{
				cursor->next->prev = cursor->prev; // Nachfolger auf den Vorgänger zeigen lassen
				cursor->prev->next = cursor->next; // Vorgänger auf den Nachfolger zeigen lassen
				delete cursor;
				return true;
			}
			cursor = cursor->next;
		}
	}
	return false; // Element nicht gefunden
}

////////////////////////////////////////////////////////////////////////////
// hinten anfügen, analog zu enqueuehead
void List::enqueuetail(const Student& stud)
{
	ListElem* neu = new ListElem;
	neu->data = stud;
	neu->next = NULL; // das letzte Element hat keinen Nachfolger.
	if (tail == NULL) // Liste leer??
	{
		neu->prev = NULL;
		tail = neu;
	}
	else
	{
		neu->prev = tail;
		tail->next = neu; // neues Element wird Nachfolger des alten letzten Elementes.
	}
	tail = neu;
}


