#include "Vektor.h"

#include <cmath>
#include <iostream>
using namespace std;
Vektor::Vektor(double inX, double inY, double inZ)
{
	x = inX;
	y = inY;
	z = inZ;
}

Vektor::~Vektor()
{
}

/* gibt den Vektor auf der Konsole aus. */
void Vektor::ausgabe()
{
	cout << "  " << x << "\n" << "( " << y << " )\n" << "  " << z << endl;
}

/* gibt die Länge des Vektors zurück. */
double Vektor::length()
{
	return sqrt(x*x + y*y + z*z); // uses camth!
}

/* gibt einzelne Komponenten des Vektors zurück */
double Vektor::xComponent(){	return x;	}
double Vektor::yComponent(){	return y;	}
double Vektor::zComponent(){	return z;	}

/* subtrahiert den übergebenen Vektor vom aktuellen */
void Vektor::subtract(Vektor v)
{
	this->x -= v.x;
	this->y -= v.y;
	this->z -= v.z;
}

/* addiert die Vektoren a und b und gibt einen neuen Vektor zurück */
Vektor Vektor::add(Vektor a, Vektor b)
{
	Vektor result(a.x+b.x, a.y+b.y, a.z+b.z);
	return result;
}

/* rotiert den Vektor v um die z-Achse mit Winkel angle. */
Vektor Vektor::rotate(Vektor v, double angle)
{
	Vektor result(cos(angle)*v.x - sin(angle)* v.y, // Rotationsmatrix aus den Skript.
			sin(angle)*v.x + cos(angle)*v.y,
			v.z);
	return result;
}
