#include "Vektor.h"
#include <cmath>
#include <iostream>
#define ERDRADIUS 6371000 //m
#define PI 3.1415926538979
using namespace std;

int main()
{
	int eingabe = 0;
	cout << "Teilaufgabe (1 oder 2)?\t";
	cin >> eingabe;
	if (eingabe == 1) // Einfach die Klasse Vektor austesten
	{
		Vektor v(3,4,5);
		Vektor s(1,2,3);

		cout << "Vektor v konstruiert:" << endl;
		v.ausgabe();
		cout << "Länge von v: " << v.length() << endl;

		cout << "Vektor s konstruiert:" << endl;
		s.ausgabe();
		cout << "Länge von s: " << s.length() << endl;

		v.subtract(s);
		cout << "v - s = " << endl;
		v.ausgabe();

		cout << "(v - s) + s =" << endl;
		Vektor summe = v.add(v,s);
		summe.ausgabe();

		cout << "(v - s) rotiert um 90°:" << endl;
		Vektor rotiert = v.rotate(v, PI);
		rotiert.ausgabe();
		return 0;
	}
	else if (eingabe == 2) // Das Horizontproblem
	/** Es wird der Winkel zwischen Beobachter und Horizont berechnet,
	 * dann wird der Vektor des Erdradius um diesen Winkel gedreht und
	 * der Ortsvektor des Beobachters davon subtrahiert.
	 * Die Länge des resultierenden Vektors ist die Sichtweite.
	 */
	{
		double augenhoehe = 0;
		double winkel = 0;
		Vektor erdRadius(0, ERDRADIUS, 0); // zeigt entlang der Y-Achse
		Vektor sichtLinie(0,0,0);

		cout << "Bestimmung der Sichtweite zum Horizont.\n"
				<< "Geben Sie die Augenhöhe des Beobachters in m an: ";
		cin >> augenhoehe;
		Vektor beobachterRadius(0, augenhoehe + ERDRADIUS, 0); // Beobachter-Ortsvektor, zeigt entlang der Y-Achse

		winkel = acos((double)ERDRADIUS / beobachterRadius.yComponent()); // Winkel im Erdmittelpunkt

		sichtLinie = erdRadius.rotate(erdRadius, winkel); // Erdradiusvektor drehen
		sichtLinie.subtract(beobachterRadius); // Ortsvektor der Beobachters abziehen

		cout << "Der Horizont erscheint für einen Beobachter in\n" << augenhoehe
				<< " Metern Höhe " << sichtLinie.length() / 1000 << " Kilometer entfernt.";
	}
   return 0;

}
