//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 7: L�sung eines mathematischen Anwendungsproblems
//
// Datei:  Gauss.cpp
// Inhalt: Gauss-Klasse
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "Gauss.h"
#include <iostream>
using namespace std;

//////////////////////////////////////////////////////////////////////////////
///////////////////////// Funktions-Implementierung //////////////////////////
//////////////////////////////////////////////////////////////////////////////

// legt einen neuen Vektor der richtigen Dimension an.
Gauss::Gauss(int n)
{
	x = new Vektor(n);
}

// Destruktor
Gauss::~Gauss(){
	delete x;
}

// löst das Gleichungssystem
Vektor Gauss::loese(QMatrix A, Vektor b)
{
	stufenForm(A, b);
	rueckwaertsEinsetzen(A, b);
	return *x;
}

// bringt das LGS in die Stufenform (gauss algorithm)
void Gauss::stufenForm(QMatrix& A, Vektor& b)
{
	int dimension = A.getDim();

	for (int i = 0; i < dimension; ++i) // Spalten durchlaufen
	{
		for (int j = i+1; j < dimension; ++j) // Zeilen durchlaufen
		{
			double multiplikator = A.get(j,i) / A.get(i,i);

			// Elemente von b umrechnen
			b.set(j, b.get(j)-b.get(i)*multiplikator);
			// Elemente von A umrechnen
			for (int k = i+1; k < dimension; ++k)
			{
				A.set(j,k, A.get(j,k)-A.get(i,k)*multiplikator);
			}
		}
	}
}

// setzt rückwärts ein
void Gauss::rueckwaertsEinsetzen(QMatrix& A, Vektor& b)
{
	int dimension = A.getDim();

	x->set(dimension-1, b.get(dimension-1)); // letzte Komponente übernehmen.

	// implementiert die Formel aus dem Skript
	for (int i = dimension-2; i >= 0; --i)
	{
		double temp = b.get(i);
		for (int k = i+1; k < dimension; ++k)
		{
			temp -= A.get(i,k)*x->get(k);
		}
		x->set(i, temp/A.get(i,i));
	}
}
//////////////////////////////////////////////////////////////////////////////
