//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 7: L�sung eines mathematischen Anwendungsproblems
//
// Datei:  LR.cpp
// Inhalt: LR-Klasse
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include "LR.h"
#include <iostream>
using namespace std;

//////////////////////////////////////////////////////////////////////////////
///////////////////////// Funktions-Implementierung //////////////////////////
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
LR::LR(int n)
{
	x = new Vektor(n);
	y = new Vektor(n);
	L = new QMatrix(n);
	R = new QMatrix(n);
}

LR::~LR()
{
	delete x;
	delete y;
	delete L;
	delete R;
}

//////////////////////////////////////////////////////////////////////////////
Vektor LR::loese(QMatrix A, Vektor b)
{
	zerlege(A);
	//cout << "A zerlegt" << endl;
	//cout << A << endl;
	erzeugeLundR(A);
	//cout << "L" << endl;
	//cout << *L << endl;
	//cout << "R" << endl;
	//cout << *R << endl;
	vorwaertsEinsetzen(b);
	//cout << "y" << endl;
	//cout << *y << endl;
	rueckwaertsEinsetzen();
	
	return *x;
}

//////////////////////////////////////////////////////////////////////////////
void LR::zerlege(QMatrix& A)
{
	int dimension = A.getDim();

	for (int i = 0; i < dimension; ++i)
	{
		for (int j = i+1; j < dimension; ++j)
		{
			A.set(j,i,
					(A.get(j,i) / A.get(i,i))
					);
			for (int k = i+1; k < dimension; ++k)
			{
				A.set(j,k,
						(A.get(j,k) - A.get(j,i) * A.get(i,k))
						);
			}
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
// Schreibe aus der Matrix A in die Matrizen L und R
void LR::erzeugeLundR(QMatrix& A)
{
	int dimension = A.getDim();
	// komponentenweise kopieren.
	for (int i = 0; i < dimension; ++i)
		{
			for (int j = 0; j < dimension; ++j)
			{
				// wenn j > i dann in die linke Matrix, sonst in die rechte.
				if (j>i) L->set(j,i, A.get(j,i));
				else R->set(j,i, A.get(j,i));
				if (i == j) L->set(i,j, 1); // die Einsen reinsetzen
			}
		}
}

//////////////////////////////////////////////////////////////////////////////
// implementiert das Vorwärtseinsetzen unter Verwendung der Formel aus dem Skript.
void LR::vorwaertsEinsetzen(Vektor& b)
{
	int dimension = L->getDim();
	y->set(0, b.get(0)); // y_1 setzen

	for (int i = 0; i < dimension; ++i)
	{
		double temp = 0;
		for (int k = 0; k < i; ++k)
		{
			temp += L->get(i,k) * y->get(k);
		}
		y->set(i, (b.get(i)-temp));
	}
}

//////////////////////////////////////////////////////////////////////////////
void LR::rueckwaertsEinsetzen()
{
	int dimension = L->getDim();
	x->set(dimension-1, y->get(dimension-1) / R->get(dimension-1, dimension-1)); // x_n setzen

	for (int i = dimension-1; i >= 0; --i) // von unten nach oben berechnen
	{
		double temp = 0;
		for (int k = i+1; k <= dimension-1; ++k)
		{
			temp += R->get(i,k) * x->get(k);
		}
		x->set(i, (y->get(i)-temp)/R->get(i,i));
	}

}














