//////////////////////////////////////////////////////////////////////////////
// Praktikum Informatik 1
// Versuch 8.1: Sortierverfahren, Templates
//
// Datei:  StackSpeicher.h
// Inhalt: generischer Stackspeicher
//////////////////////////////////////////////////////////////////////////////

#ifndef STACKSPEICHER_H_
#define STACKSPEICHER_H_

//////////////////////////////////////////////////////////////////////////////
///////////////////////////////// INCLUDES ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <string>
using namespace std;
//////////////////////////////////////////////////////////////////////////////
///////////////////////// CLASS DECLARATION //////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// StackKlasse
template<int size, class T>
class StackSpeicher
{
  public:
	StackSpeicher();
	void push (const T& e);
	void pop (T& e);
	void sort();
  
  private:
	int partition(int l, int r);
	void quickSort(int left, int right);
	T space[size];
	int index;
};

//////////////////////////////////////////////////////////////////////////////
////////////////// Funktions-Implementierung /////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////
// Konstruktor
template <int size, class T>
StackSpeicher <size, T> :: StackSpeicher():index(-1)
{
}


//////////////////////////////////////////////////////////////////////////////
// Einfügen
template <int size, class T>
void StackSpeicher <size, T>::push(const T& e)
{
	if (index < (size-1))
	{
		index += 1;
		space[index] = e;
	}
}

//////////////////////////////////////////////////////////////////////////////
// Entnehmen
template<int size, class T>
void StackSpeicher<size, T>::pop(T& e)
{
	if (index >= 0)
	{
		e = space[index];
		index -= 1;
	}
}

//////////////////////////////////////////////////////////////////////////////
// sortieren nach Quicksort-algorithm
template<int size, class T>
int StackSpeicher <size, T>::partition(int left, int right)
{
	T pivot = space[right];
	int l = left;
	int r = right;
	int k = r;

	while(1)
	{
		while(space[l] >= pivot && l < right) l++; // überladener Operator
		while(space[r] <= pivot && r >= left) r--;

		if (l >= r) break;
		else
		{
			T swap = space[l];	// tauschen
			space[l] = space[r];
			space[r] = swap;
		}
	}

	T swap = space[l];	// Trennelement in die Mitte schieben
	space[l] = space[k];
	space[k] = swap;
	return l;
}

template<int size, class T>
void StackSpeicher <size, T>::quickSort(int left, int right)
{
	if (right <= left) return; // Rekursionsausstieg

	int k = partition(left,right);
	quickSort(left, k-1);
	quickSort(k+1, right);
}

//////////////////////////////////////////////////////////////////////////////
// startet den Quicksort einmalig mit den richitgen Parametern.
template<int size, class T>
void StackSpeicher <size, T>::sort()
{
	quickSort(0, index);
}

#endif /*STACKSPEICHER_H_*/
